Imports System.Text
Imports System.IO
Imports System.Windows
Imports System.Data.SqlServerCe
Imports System.Data
Imports Symbol.ResourceCoordination
Imports BT_LF


Public Class frmMain

    Const UpdateSql = "UPDATE [tblDaten] SET [VarField1] = @p1, [VarField2] = @p2, [VarField3] = @p3, [VarField4] = @p4, [VarField5] = @p5 " ' WHERE ([VarField1] = @p1)"
    Const InsertSql = "INSERT INTO [tblDaten] ([VarField1], [VarField2], [VarField3], [VarField4], [VarField5]) VALUES (@p1, @p2, @p3, @p4, @p5)"


    Public conn_bar As System.Data.SqlServerCe.SqlCeConnection = Nothing
    Public cmd_bar As System.Data.SqlServerCe.SqlCeCommand = Nothing
    Public rs_bar As System.Data.SqlServerCe.SqlCeDataAdapter = Nothing
    Public ds_bar As DataSet = Nothing

    Public Reader_Typ As Integer
    Public HF_Reader_Typ As Integer

    Public myGridStyle As DataGridTableStyle
    Public InBartecDB As String
    Public IsDBActive As Boolean
    Public IsReaderActive As Boolean
    Public Root As String
    Public LFComport As Integer
    Public DBName As String = "\TIDBartec.sdf"

    Public TagType As Integer = 0
    Public TagName As String = "0 - EM 41xx (UNIQUE)"
    Public RFIDData As String
    Public frmLFDlg As frmLF
    Public frmHFDlg As frmHF
    Public frmUHFDlg As frmUHF
    Public frmRFIDDataDlg As frmRFIDData
    Public errortext As String
    Private KeyCount As Integer = 0
    Public WithEvents RFID As New RFIDFeig
    Public WithEvents MyBTLF As New BT_LF.BTLF

    Private KeyTrigger As Symbol.ResourceCoordination.Trigger = Nothing

    Declare Function MessageBeep Lib "coredll.dll" (ByVal wType As Int16) As Int16


    Private Sub InitTrigger()
        KeyTrigger = New Symbol.ResourceCoordination.Trigger(New Symbol.ResourceCoordination.TriggerDevice(Symbol.ResourceCoordination.TriggerID.ALL_TRIGGERS, New ArrayList()))
        AddHandler KeyTrigger.Stage1Notify, New Symbol.ResourceCoordination.Trigger.TriggerEventHandler(AddressOf trigger_Stage1Notify)
        AddHandler KeyTrigger.Stage2Notify, New Symbol.ResourceCoordination.Trigger.TriggerEventHandler(AddressOf trigger_Stage2Notify)
    End Sub

    Private Sub trigger_Stage1Notify(ByVal sender As Object, ByVal e As Symbol.ResourceCoordination.TriggerEventArgs)
        ' TRIGGER3 = LEFT SCAN_BUTTON'
        ' TRIGGER4 = RIGHT SCAN_BUTTON'
        ' TRIGGER1 = MIDDLE SCAN_BUTTON' 

        If Not frmLFDlg Is Nothing Then
            If Not frmLFDlg.IsKeyAction Then
                If e.TriggerID.ToString() = "TRIGGER1" Or e.TriggerID.ToString() = "TRIGGER3" Or e.TriggerID.ToString() = "TRIGGER4" Then
                    If Reader_Typ = 1 Then
                        frmLFDlg.ReadTransponder()
                    End If
                End If
            End If
        End If
        If Not frmHFDlg Is Nothing Then
            If Not frmHFDlg.IsKeyAction Then
                If e.TriggerID.ToString() = "TRIGGER1" Or e.TriggerID.ToString() = "TRIGGER3" Or e.TriggerID.ToString() = "TRIGGER4" Then
                    If Reader_Typ = 2 Then ' 11.08.2009
                        KeyCount = KeyCount + 1
                        If KeyCount = 2 Then
                            KeyCount = 0
                            frmHFDlg.ReadTransponder()
                        End If
                    End If
                End If
            End If
        End If
        If Not frmUHFDlg Is Nothing Then
            If Not frmUHFDlg.IsKeyAction Then
                If e.TriggerID.ToString() = "TRIGGER1" Or e.TriggerID.ToString() = "TRIGGER3" Or e.TriggerID.ToString() = "TRIGGER4" Then
                    If Reader_Typ = 3 Then ' 08.09.2009
                        KeyCount = KeyCount + 1
                        If KeyCount = 2 Then
                            KeyCount = 0
                            frmUHFDlg.ReadTransponder()
                        End If
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub trigger_Stage2Notify(ByVal sender As Object, ByVal e As Symbol.ResourceCoordination.TriggerEventArgs)
        ' TRIGGER3 = LEFT SCAN_BUTTON'
        ' TRIGGER4 = RIGHT SCAN_BUTTON'
        ' TRIGGER1 = MIDDLE SCAN_BUTTON' 
        If Not frmLFDlg Is Nothing Then
            If Not frmLFDlg.IsKeyAction Then
                If e.TriggerID.ToString() = "TRIGGER1" Or e.TriggerID.ToString() = "TRIGGER3" Or e.TriggerID.ToString() = "TRIGGER4" Then
                    If Reader_Typ = 1 Then ' 11.08.2009'
                        KeyCount = KeyCount + 1
                        If KeyCount = 1 Then
                            frmLFDlg.ReadTransponder()
                        Else
                            KeyCount = KeyCount + 1
                        End If
                        If KeyCount >= 2 Then
                            KeyCount = 0
                        End If
                    End If
                End If
            End If
        End If
        If Not frmHFDlg Is Nothing Then
            If Not frmHFDlg.IsKeyAction Then
                If e.TriggerID.ToString() = "TRIGGER1" Or e.TriggerID.ToString() = "TRIGGER3" Or e.TriggerID.ToString() = "TRIGGER4" Then
                    If Reader_Typ = 2 Then ' 11.08.2009
                        KeyCount = KeyCount + 1
                        If KeyCount = 2 Then
                            KeyCount = 0
                            frmHFDlg.ReadTransponder()
                        End If
                    End If
                End If
            End If
        End If
        If Not frmUHFDlg Is Nothing Then
            If Not frmUHFDlg.IsKeyAction Then
                If e.TriggerID.ToString() = "TRIGGER1" Or e.TriggerID.ToString() = "TRIGGER3" Or e.TriggerID.ToString() = "TRIGGER4" Then
                    If Reader_Typ = 3 Then ' 11.08.2009
                        KeyCount = KeyCount + 1
                        If KeyCount = 2 Then
                            KeyCount = 0
                            frmUHFDlg.ReadTransponder()
                        End If
                    End If
                End If
            End If
        End If
    End Sub

    Public Sub PlaySound()
        Dim sound As New Sound(Root & "\Laser.wav")
        If SoundItem.Checked Then
            sound.Play()
        Else
            MessageBeep(&H40&)
        End If
    End Sub


    Private Sub ReadIni()
        Dim tmpInt As Integer
        Reader_Typ = Ini.Settings.GetInt("Reader_Typ")
        InBartecDB = Ini.Settings.GetString("BartecDB")
        LFComport = Ini.Settings.GetInt("LFComport")
        TagName = Ini.Settings.GetString("TagName")
        TagType = Ini.Settings.GetInt("TagType")
        MyBTLF.TitanPassword = Ini.Settings.GetString("TitanPassword")
        If MyBTLF.TitanPassword = "" Then
            MyBTLF.TitanPassword = "00000000"
            Ini.Settings.SetValue("TitanPassword", MyBTLF.TitanPassword)
        End If

        MyBTLF.Hitag2Password = Ini.Settings.GetString("Hitag2Password")
        If MyBTLF.Hitag2Password = "" Then
            MyBTLF.Hitag2Password = "4D494B52"
            Ini.Settings.SetValue("Hitag2Password", MyBTLF.Hitag2Password)
        End If

        tmpInt = Ini.Settings.GetInt("ReadTimeOut")
        If tmpInt <= 0 Then
            tmpInt = 2000
            MyBTLF.ReadTimeOut = tmpInt
            Ini.Settings.SetValue("ReadTimeOut", MyBTLF.ReadTimeOut)
        Else
            MyBTLF.ReadTimeOut = tmpInt
        End If

        tmpInt = Ini.Settings.GetInt("WriteTimeOut")
        If tmpInt <= 0 Then
            tmpInt = 2000
            MyBTLF.WriteTimeOut = tmpInt
            Ini.Settings.SetValue("WriteTimeOut", MyBTLF.WriteTimeOut)
        End If

        RFID.MifareKey = Ini.Settings.GetString("MifareKey")
        If RFID.MifareKey = "" Then
            RFID.MifareKey = "000000000000"
            Ini.Settings.SetValue("MifareKey", RFID.MifareKey)
        End If

        HF_Reader_Typ = Ini.Settings.GetInt("HF_Reader_Typ")
        If HF_Reader_Typ < 0 Then
            HF_Reader_Typ = 0
        End If

        If TagName = "" Then
            TagName = "1 - HITAG S"
            Ini.Settings.SetValue("TagName", TagName)
        End If

        If TagType < 0 Then
            TagType = 1
            Ini.Settings.SetValue("TagType", TagType)
        End If

        If LFComport <= 0 Then
            LFComport = 1
            Ini.Settings.SetValue("LFComport", LFComport)
        End If

        If InBartecDB = "" Then
            Ini.Settings.SetValue("BartecDB", Root & DBName)
            InBartecDB = Root & DBName
            Ini.Settings.SetValue("BartecDB", InBartecDB)
        End If
        SoundItem.Checked = Ini.Settings.GetBool("Sound")
    End Sub

    Public Sub WriteIni()
        Ini.Settings.SetValue("Reader_Typ", Reader_Typ)
        Ini.Settings.SetValue("HF_Reader_Typ", HF_Reader_Typ)
        Ini.Settings.SetValue("BartecDB", InBartecDB)
        Ini.Settings.SetValue("LFComport", LFComport)
        Ini.Settings.SetValue("TagName", TagName)
        Ini.Settings.SetValue("TagType", TagType)
        Ini.Settings.SetValue("TitanPassword", MyBTLF.TitanPassword)
        Ini.Settings.SetValue("Hitag2Password", MyBTLF.Hitag2Password)
        Ini.Settings.SetValue("MifareKey", RFID.MifareKey)
        Ini.Settings.SetValue("Sound", SoundItem.Checked)
        Ini.Settings.SetValue("WriteTimeOut", MyBTLF.WriteTimeOut)
    End Sub

    Private Function InitDB() As Boolean
        Dim Index As Integer
        Dim Result As Boolean
        Result = False
        Index = 0
        If File.Exists(InBartecDB) Then
            lbDBInfo.Text = "Database: " & DBName
            Result = True
        Else
            lbDBInfo.Text = "Database not found"
        End If
        lbDBInfo.Refresh()
        Return Result
    End Function

    Public Function OpenConnection() As Boolean
        If File.Exists(InBartecDB) Then
            conn_bar = New SqlCeConnection
            conn_bar.ConnectionString = "Data Source = " & InBartecDB & "; Password = 0147"
            conn_bar.Open()
            rs_bar = New SqlCeDataAdapter("", conn_bar)
            cmd_bar = New SqlCeCommand("", conn_bar)
            ds_bar = New DataSet
            OpenConnection = True
        Else
            OpenConnection = False
            MsgBox("DB NOT FOUND: " & InBartecDB, vbExclamation, Text)
        End If
    End Function

    Public Sub CloseConnection()
        If Not rs_bar Is Nothing Then
            rs_bar.Dispose()
            rs_bar = Nothing
        End If

        If Not cmd_bar Is Nothing Then
            cmd_bar.Dispose()
            cmd_bar = Nothing
        End If

        If Not ds_bar Is Nothing Then
            ds_bar.Dispose()
            ds_bar = Nothing
        End If

        If Not conn_bar Is Nothing Then
            If conn_bar.State = ConnectionState.Open Then
                conn_bar.Close()
            End If
            conn_bar = Nothing
        End If
    End Sub

    Private Sub ExitItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitItem.Click
        Close()
    End Sub

    Private Sub btReaderLF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReaderLF.Click
        Dim MyLFVersion As String
        If Reader_Typ = 0 Then
            'MsgBox("No Rader found" & vbCrLf & _
            '      "Please initialize first a Reader")
            Exit Sub
        End If
        KeyCount = 0
        If Reader_Typ = 1 Then
            frmLFDlg = New frmLF
            If MyBTLF.Active Then
                MyLFVersion = MyBTLF.GetVersion
                frmLFDlg.lbReaderInfo.Text = "Reader: " & MyLFVersion
                frmLFDlg.SetItemsToListView(MyLFVersion)
                frmLFDlg.IsFirst = True
                frmLFDlg.TagView.SelectedIndex = frmLFDlg.GetTagTypeIndex(TagType)
                frmLFDlg.IsFirst = False
                frmLFDlg.SetActiveButton()
            End If
            frmLFDlg.ShowDialog()
            If Not frmLFDlg Is Nothing Then
                frmLFDlg.Dispose()
                frmLFDlg = Nothing
            End If
        End If
        If Reader_Typ = 2 Then
            frmHFDlg = New frmHF
            If RFID.IsActive Then
                RFID.CheckReaderCTS()
                If RFID.GetReaderInfo(0) Then
                    frmHFDlg.lbReaderInfo.Text = RFID.InfoReader(2)
                Else
                    frmHFDlg.lbReaderInfo.Text = "No Reader"
                End If
            End If
            frmHFDlg.ShowDialog()
            If Not frmHFDlg Is Nothing Then
                frmHFDlg.Dispose()
                frmHFDlg = Nothing
            End If
        End If
        If Reader_Typ = 3 Then
            frmUHFDlg = New frmUHF
            If RFID.IsActive Then
                RFID.CheckReaderCTS()
                If RFID.GetReaderInfo(0) Then
                    frmUHFDlg.lbReaderInfo.Text = RFID.InfoReader(2)
                Else
                    frmUHFDlg.lbReaderInfo.Text = "No Reader"
                End If
            End If
            frmUHFDlg.ShowDialog()
            If Not frmUHFDlg Is Nothing Then
                frmUHFDlg.Dispose()
                frmUHFDlg = Nothing
            End If
        End If
    End Sub

    Private Sub CloseReaderAll()
        Try
            MyBTLF.Active = False
            RFID.ReaderUnload()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub CloseReader(ByVal Index As Integer)
        Try
            If Index = 0 Then
                If Reader_Typ = 1 Then
                    MyBTLF.Active = False
                End If
                If Reader_Typ = 2 Then
                    RFID.ReaderUnload()
                End If
                If Reader_Typ = 3 Then
                    RFID.ReaderUnload()
                End If
            End If
            If Index = 1 Then
                If MyBTLF.Active Then
                    MyBTLF.Active = False
                End If
                RFID.ReaderUnload()
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub CloseAll()
        Try
            CloseReader(0)
            InitTimer.Enabled = False
            WriteIni()
            CloseConnection()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub frmMain_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        CloseAll()
    End Sub

    Private Sub frmMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If MsgBox("Exit Program ?", MsgBoxStyle.YesNo, Text) = MsgBoxResult.No Then
            e.Cancel = True
        End If
    End Sub


    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Root = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetModules(0).FullyQualifiedName)
        ReadIni()
        lbDBInfo.Text = "Search database..."
        lbDBInfo.Refresh()
        IsDBActive = InitDB()
        lbReaderInfo.Text = "Search Reader..."
        lbReaderInfo.Refresh()
        InitTrigger()
        InitTimer.Enabled = True
    End Sub



    Private Sub CheckReaderOnBoard(ByVal index As Integer)
        If index = 0 Then
            Reader_Typ = 1
            CheckReaderOnBoard(1)
            If Reader_Typ = 0 Then
                Reader_Typ = 2
                CloseReader(0)
                CheckReaderOnBoard(1)
            Else
                Exit Sub
            End If

            If Reader_Typ = 0 Then
                Reader_Typ = 3
                CloseReader(0)
                CheckReaderOnBoard(1)
            Else
                Exit Sub
            End If
        End If
        If index > 0 Then
            CloseReader(1)
            lbReaderInfo.Text = "Search Reader..."
            lbReaderInfo.Refresh()
            btReaderLF.Text = "Reader Config."
            btReaderLF.Refresh()
            btData.Text = "Read/Write Data"
            btData.Refresh()
            IsReaderActive = False
            If Reader_Typ = 1 Then
                lbReaderTyp.Text = "LF-Reader"
                IsReaderActive = InitReaderLF()
                If IsReaderActive Then
                    System.Threading.Thread.Sleep(100)
                    System.Windows.Forms.Application.DoEvents()
                    lbReaderInfo.Text = "Reader: " & Trim(fc.MyBTLF.GetVersion)
                    If lbReaderInfo.Text = "Reader: " Then
                        lbReaderInfo.Text = "No Reader found"
                        CloseReader(0)
                        Reader_Typ = 0
                        Exit Sub
                    End If
                    lbReaderInfo.Refresh()
                    If Not fc.MyBTLF.CTSInfo Then
                        lbReaderInfo.Text = "No Signal found"
                        lbReaderInfo.Refresh()
                        Exit Sub
                    End If
                    btReaderLF.Text = "LF Reader Config."
                    btReaderLF.Refresh()
                    btData.Text = "LF Read/Write Data"
                    btData.Refresh()
                End If
            End If
            If Reader_Typ = 2 Then
                lbReaderTyp.Text = "HF-Reader"
                IsReaderActive = InitReaderHF()
                If IsReaderActive Then
                    RFID.CheckReaderCTS()
                    If RFID.GetReaderInfo(0) And RFID.IsHF Then
                        lbReaderInfo.Text = RFID.InfoReader(2)
                        lbReaderInfo.Refresh()
                        btReaderLF.Text = "HF Reader Config."
                        btReaderLF.Refresh()
                        btData.Text = "HF Read/Write Data"
                        btData.Refresh()
                    Else
                        lbReaderInfo.Text = "No Reader found"
                        lbReaderInfo.Refresh()
                        Reader_Typ = 0
                        CheckVersionHF()
                    End If
                    RFID.GetUID()
                Else
                    lbReaderInfo.Text = "No Reader found"
                    lbReaderInfo.Refresh()
                    Reader_Typ = 0
                End If
            End If
            If Reader_Typ = 3 Then
                lbReaderTyp.Text = "UHF-Reader"
                IsReaderActive = InitReaderUHF()
                If IsReaderActive Then
                    RFID.CheckReaderCTS()
                    If RFID.GetReaderInfo(0) And RFID.IsUHF Then
                        lbReaderInfo.Text = RFID.InfoReader(2)
                        lbReaderInfo.Refresh()
                        btReaderLF.Text = "UHF Reader Config."
                        btReaderLF.Refresh()
                        btData.Text = "UHF Read/Write Data"
                        btData.Refresh()
                    Else
                        lbReaderInfo.Text = "No Reader found"
                        lbReaderInfo.Refresh()
                        Reader_Typ = 0
                        CheckVersionUHF()
                    End If
                    RFID.GetUID()
                Else
                    lbReaderInfo.Text = "No Reader found"
                    lbReaderInfo.Refresh()
                    Reader_Typ = 0
                End If
            End If
        End If
    End Sub


    Private Sub InitTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InitTimer.Tick
        InitTimer.Enabled = False
        System.Threading.Thread.Sleep(100)
        System.Windows.Forms.Application.DoEvents()
        Try
            Try
                CheckReaderOnBoard(Reader_Typ)
            Catch ex As Exception

            End Try
        Finally
            InitItem.Enabled = True
        End Try
    End Sub

    Private Sub CheckVersionHF()
        If IsReaderActive Then
            RFID.CheckReaderCTS()
            If RFID.GetReaderInfo(0) And RFID.IsHF Then
                lbReaderInfo.Text = RFID.InfoReader(2)
                lbReaderInfo.Refresh()
                btReaderLF.Text = "HF Reader Config."
                btReaderLF.Refresh()
                btData.Text = "HF Read/Write Data"
                btData.Refresh()
                Reader_Typ = 2
            Else
                lbReaderInfo.Text = "No Reader found"
                lbReaderInfo.Refresh()
            End If
        End If
    End Sub

    Private Sub CheckVersionUHF()
        If IsReaderActive Then
            RFID.CheckReaderCTS()
            If RFID.GetReaderInfo(0) And RFID.IsUHF Then
                lbReaderInfo.Text = RFID.InfoReader(2)
                lbReaderInfo.Refresh()
                btReaderLF.Text = "UHF Reader Config."
                btReaderLF.Refresh()
                btData.Text = "UHF Read/Write Data"
                btData.Refresh()
                Reader_Typ = 3
            Else
                lbReaderInfo.Text = "No Reader found"
                lbReaderInfo.Refresh()
            End If
        End If
    End Sub

    Private Function InitReaderLF() As Boolean
        Dim Result As Boolean
        Result = False
        Try
            fc.MyBTLF.Comport = "COM" & LFComport
            fc.MyBTLF.ShutDownActive = False
            fc.MyBTLF.PowerOnTime = 10000
            fc.MyBTLF.PowerCheck = True
            fc.MyBTLF.Active = True
            Result = fc.MyBTLF.Active
        Catch ex As Exception
            MessageBox.Show("ERROR : " & ex.Message, "ERROR")
            CloseReader(1)
        End Try
        Return Result
    End Function

    Public Function InitReaderHF() As Boolean
        Dim Result As Boolean
        Result = False
        Try
            RFID.ReaderUnload()
            RFID.Initialize(1)
            Result = RFID.IsActive
        Catch ex As Exception
            MessageBox.Show("ERROR : " & ex.Message, "ERROR")
            CloseReader(1)
        End Try
        Return Result
    End Function

    Public Function InitReaderUHF() As Boolean
        Dim Result As Boolean
        Result = False
        Try
            RFID.ReaderUnload()
            RFID.Initialize(1)
            Result = RFID.IsActive
        Catch ex As Exception
            MessageBox.Show("ERROR : " & ex.Message, "ERROR")
            CloseReader(1)
        End Try
        Return Result
    End Function

    Private Sub CloseAllForms()
        If Not frmLFDlg Is Nothing Then
            frmLFDlg.Close()
            frmLFDlg.Dispose()
            frmLFDlg = Nothing
        End If
        If Not frmRFIDDataDlg Is Nothing Then
            If Not frmRFIDDataDlg.frmDataDlg Is Nothing Then
                frmRFIDDataDlg.Close()
                frmRFIDDataDlg.Dispose()
                frmRFIDDataDlg = Nothing
            End If
            frmRFIDDataDlg.Close()
            frmRFIDDataDlg.Dispose()
            frmRFIDDataDlg = Nothing
        End If
    End Sub

    Private Sub MyBTLF_PortDown(ByVal sender As Object, ByVal IsDown As Boolean) Handles MyBTLF.PortDown
        Try
            If IsDown Then
                lbPower.Text = "Port Down"
            Else
                lbPower.Text = "Port ON"
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub MyBTLF_ReadyToShutDown(ByVal Sender As Object, ByVal ReaderDown As Boolean) Handles MyBTLF.ReadyToShutDown
        If ReaderDown Then
            Try
                CloseAllForms()
            Catch ex As Exception
            End Try
            Try
                Close()
            Catch ex As Exception
            End Try
        End If
    End Sub

    Private Sub MyTLM30_TLMData(ByVal Sender As Object, ByVal Direction As String, ByVal Data As String) Handles MyBTLF.TLMData
        If Not frmLFDlg Is Nothing Then
            If frmLFDlg.EventItem.Checked Then
                frmLFDlg.InfoAdd(Direction & " " & Data)
            End If
        End If
    End Sub

    Private Sub btData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btData.Click
        If Reader_Typ = 0 Then
            'MsgBox("No Rader found" & vbCrLf & _
            '      "Please initialize first a Reader")
            Exit Sub
        End If
        frmRFIDDataDlg = New frmRFIDData
        If Reader_Typ = 1 Then
            frmRFIDDataDlg.lbInfo1.Text = TagName
            frmRFIDDataDlg.TagInfo = TagName
            If MyBTLF.Active Then
                frmRFIDDataDlg.lbReaderInfo.Text = MyBTLF.GetVersion
            End If
        End If
        If Reader_Typ = 2 Then
            If fc.HF_Reader_Typ = 0 Then
                frmRFIDDataDlg.lbInfo1.Text = "ISO 15693 - RW"
                frmRFIDDataDlg.TagInfo = "ISO 15693 - RW"
            End If
            If fc.HF_Reader_Typ = 1 Then
                frmRFIDDataDlg.lbInfo1.Text = "ISO 14443 (Mifare) - RW"
                frmRFIDDataDlg.TagInfo = "ISO 14443 (Mifare) - RW"
            End If
            If RFID.IsActive Then
                RFID.CheckReaderCTS()
                If RFID.GetReaderInfo(0) Then
                    frmRFIDDataDlg.lbReaderInfo.Text = RFID.InfoReader(2)
                End If
            End If
        End If
        If Reader_Typ = 3 Then
            frmRFIDDataDlg.lbInfo1.Text = "EPC Gen 2"
            frmRFIDDataDlg.TagInfo = "EPC Gen 2"
            If RFID.IsActive Then
                RFID.CheckReaderCTS()
                If RFID.GetReaderInfo(0) Then
                    frmRFIDDataDlg.lbReaderInfo.Text = RFID.InfoReader(2)
                End If
            End If
        End If
        frmRFIDDataDlg.ShowDialog()
        If Not frmRFIDDataDlg Is Nothing Then
            frmRFIDDataDlg.Dispose()
            frmRFIDDataDlg = Nothing
        End If
    End Sub

    Public Sub SC(ByVal Index As Integer)
        If Index = 0 Then
            Cursor.Current = Cursors.Default
        End If
        If Index = 1 Then
            Cursor.Current = Cursors.WaitCursor
        End If
    End Sub

    Public Function GetRecordCount() As Integer
        Dim cmd As SqlServerCe.SqlCeCommand = Nothing
        Dim rs As SqlServerCe.SqlCeDataReader = Nothing
        GetRecordCount = 0
        cmd = New SqlServerCe.SqlCeCommand
        cmd.Connection = conn_bar
        cmd.CommandText = "SELECT COUNT(VarField1) FROM tblDaten"
        rs = cmd.ExecuteReader()
        rs.Read()
        GetRecordCount = rs.GetInt32(0)
        rs.Close()
        rs.Dispose()
        rs = Nothing
        cmd.Dispose()
        cmd = Nothing
        Return GetRecordCount
    End Function

    Private Sub CheckBox1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckStateChanged
        If CheckBox1.Checked Then
            lbPowerCheck.Text = "Powercheck = ON"
            Me.MyBTLF.PowerCheck = True
        Else
            lbPowerCheck.Text = "Powercheck = OFF"
            Me.MyBTLF.PowerCheck = True
        End If
    End Sub

    Private Sub SetTagTyp(ByVal Value As String)
        'LFItem.Checked = Value = "LF Reader"
        'HFItem.Checked = Value = "HF Reader"
        'UHFItem.Checked = Value = "UHF Reader"
        'If LFItem.Checked Then
        'Reader_Typ = 1
        'End If
        'If HFItem.Checked Then
        '        Reader_Typ = 2
        '       End If
        'If UHFItem.Checked Then
        'Reader_Typ = 3
        'End If
        'InitTimer.Enabled = True
    End Sub

    Private Sub LFItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim MyPassDlg As New frmPass
        Dim MyText As String
        Dim MyResult As Integer
        MyText = ""
        Try
            MyPassDlg.txtPassword.Focus()
            MyResult = MyPassDlg.ShowDialog()
            MyResult = MyPassDlg.MyResult
            If MyResult = 1 Then
                MyText = MyPassDlg.txtPassword.Text
            End If
        Finally
            If Not MyPassDlg Is Nothing Then
                MyPassDlg.Dispose()
                MyPassDlg = Nothing
            End If
        End Try
        If MyResult = 1 Then
            If MyText = "0147" Then
                MsgBox("Change Reader successful")
                SetTagTyp(DirectCast(sender, MenuItem).Text)
                Exit Sub
            End If
        End If
        MsgBox("No Change Reader")
    End Sub

    Private Sub HFItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim MyPassDlg As New frmPass
        Dim MyText As String
        Dim MyResult As Integer
        MyText = ""
        Try
            MyPassDlg.txtPassword.Focus()
            MyResult = MyPassDlg.ShowDialog()
            MyResult = MyPassDlg.MyResult
            If MyResult = 1 Then
                MyText = MyPassDlg.txtPassword.Text
            End If
        Finally
            If Not MyPassDlg Is Nothing Then
                MyPassDlg.Dispose()
                MyPassDlg = Nothing
            End If
        End Try
        If MyResult = 1 Then
            If MyText = "0147" Then
                MsgBox("Change Reader successful")
                SetTagTyp(DirectCast(sender, MenuItem).Text)
                Exit Sub
            End If
        End If
        MsgBox("No Change Reader")
    End Sub

    Private Sub RFID_GetReaderText(ByVal Info_Text As String) Handles RFID.GetReaderText
        errortext = Info_Text
    End Sub

    Private Sub InitItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InitItem.Click
        InitItem.Enabled = False
        'Reader_Typ = 0
        InitTimer.Enabled = True
    End Sub

    Private Sub SoundItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SoundItem.Click
        SoundItem.Checked = Not SoundItem.Checked
    End Sub

    Private Sub UHFItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim MyPassDlg As New frmPass
        Dim MyText As String
        Dim MyResult As Integer
        MyText = ""
        Try
            MyPassDlg.txtPassword.Focus()
            MyResult = MyPassDlg.ShowDialog()
            MyResult = MyPassDlg.MyResult
            If MyResult = 1 Then
                MyText = MyPassDlg.txtPassword.Text
            End If
        Finally
            If Not MyPassDlg Is Nothing Then
                MyPassDlg.Dispose()
                MyPassDlg = Nothing
            End If
        End Try
        If MyResult = 1 Then
            If MyText = "0147" Then
                MsgBox("Change Reader successful")
                SetTagTyp(DirectCast(sender, MenuItem).Text)
                Exit Sub
            End If
        End If
        MsgBox("No Change Reader")
    End Sub

    Private Sub MenuItem4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem4.Click
        MsgBox(Me.Text & vbCrLf & "08.12.2009", MsgBoxStyle.Information)
    End Sub
End Class