'	The Settings class does all of the work. This is the 'settings 
'	definition' file. It defined two things; first it specifies the 
'	keynames used in the settings file. This allows you to use 
'	IntelliSense when reading / writing settings.
'
'	The second item is the default values. These are used if a config
'	file is not found or the config file does not contain an entry 
'	for the particular setting.


' Contains setting key names.
Public Class SettingKeys
    Public Const Key1 As String = "LNG"
    Public Const Key2 As String = "PW"
    Public Const Key3 As String = "VarField1"
    Public Const Key4 As String = "VarField2"
    Public Const Key5 As String = "VarField3"
    Public Const Key6 As String = "VarField4"
    Public Const Key7 As String = "VarField5"
    Public Const Key8 As String = "VarField6"
    Public Const Key9 As String = "VarField7"

End Class

' Default settings
Public Class SettingDefaults
    Public Shared Values As String(,) = _
    { _
     {SettingKeys.Key1, "German"}, _
     {SettingKeys.Key2, "00000000"}, _
     {SettingKeys.Key3, "Transponder-ID"}, _
     {SettingKeys.Key4, "Datum/Uhrzeit"}, _
     {SettingKeys.Key5, "Firma"}, _
     {SettingKeys.Key6, "Standort"}, _
     {SettingKeys.Key7, "Bemerkung"}, _
     {SettingKeys.Key8, "Name"}, _
     {SettingKeys.Key9, "NID"} _
    }
End Class
