Public Class frmUHF

    Public IsKeyAction As Boolean
    Private IsRefreshRFID As Boolean

    Public Sub InfoAdd(ByVal Value As String)
        Try
            If (Value = "") Or (Len(Value) = 0) Then
                Exit Sub
            End If
            'Dim itmp As New Windows.Forms.ListViewItem(Value)
            ListBox1.Items.Add(Value)
            ListBox1.SelectedIndex = ListBox1.Items.Count - 1
            If ListBox1.Items.Count >= 1000 Then
                ListBox1.Items.Clear()
            End If
        Catch ex As Exception
            '            WriteErrorFile(ex.Message)
        End Try

    End Sub

    Public Function ReadTransponder() As Boolean
        ReadTransponder = False
        IsKeyAction = True
        btReadTransponder_Click(Nothing, Nothing)
        IsKeyAction = False
        ReadTransponder = True
    End Function


    Private Sub btReadTransponder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReadTransponder.Click
        Try
            btReadTransponder.Enabled = False
            btReadWriteData.Enabled = False
            btGetVersion.Enabled = False
            fc.RFID.CheckReaderCTS()
            If cbConti.Checked Then
                InfoAdd("Start Continues Read")
            End If
            Do
                System.Windows.Forms.Application.DoEvents()
                If lbReaderInfo.Text = "No Reader" Then
                    If fc.RFID.GetReaderInfo(0) Then
                        lbReaderInfo.Text = fc.RFID.InfoReader(2)
                    Else
                        lbReaderInfo.Text = "No Reader"
                    End If
                End If
                If fc.RFID.GetUID Then
                    InfoAdd(fc.RFID.UIDNr)
                    InfoAdd(fc.RFID.TagTyp)
                    fc.PlaySound()
                Else
                    InfoAdd("No UID found")
                    InfoAdd(fc.errortext)
                    If Not fc.RFID.LastCTS Then
                        InfoAdd("Reader = Power Down")
                    End If
                    If (fc.RFID.LastErrorID = -1039) Or (fc.RFID.LastErrorID = -1030) Then
                        IsRefreshRFID = True
                        InfoAdd("Reader = Power Down")
                    Else
                        IsRefreshRFID = False
                    End If
                    If IsRefreshRFID Then
                        ListBox1.Items.Add("InitReaderUHF")
                        fc.InitReaderUHF()
                    End If
                End If
            Loop Until Not cbConti.Checked
        Finally
            btReadTransponder.Enabled = True
            btReadWriteData.Enabled = True
            btGetVersion.Enabled = True
        End Try
    End Sub

    Private Sub btGetVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetVersion.Click
        Try
            btReadTransponder.Enabled = False
            btReadWriteData.Enabled = False
            btGetVersion.Enabled = False
            fc.RFID.CheckReaderCTS()
            If fc.RFID.GetReaderInfo(0) Then
                lbReaderInfo.Text = fc.RFID.InfoReader(2)
                InfoAdd(fc.RFID.InfoReader(0))
                InfoAdd(fc.RFID.InfoReader(1))
                InfoAdd(fc.RFID.InfoReader(2))
                InfoAdd(fc.RFID.InfoReader(3))
            End If
        Finally
            btReadTransponder.Enabled = True
            btReadWriteData.Enabled = True
            btGetVersion.Enabled = True
        End Try
    End Sub

    Private Sub btReadWriteData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReadWriteData.Click
        Try
            btReadTransponder.Enabled = False
            btReadWriteData.Enabled = False
            btGetVersion.Enabled = False
            fc.RFID.CheckReaderCTS()
            If cbReadWriteBox.SelectedIndex = 0 Then
                InfoAdd("Search UID")
                If fc.RFID.GetUID Then
                    InfoAdd(fc.RFID.UIDNr)
                    InfoAdd(fc.RFID.TagTyp)
                    fc.PlaySound()

                    If fc.RFID.UIDNr.Length = 24 Then
                        If fc.RFID.ReadTagBlock24(NumBlock.Value, 4, 0) Then
                            InfoAdd(fc.RFID.BlockDataAScII)
                            txtData.Text = fc.RFID.BlockDataAScII
                            InfoAdd("Read = OK")
                        Else
                            InfoAdd("No Data found")
                            InfoAdd(fc.errortext)
                        End If
                    End If

                    If fc.RFID.UIDNr.Length = 16 Then
                        If fc.RFID.ReadTagBlock(NumBlock.Value, 2, 0) Then
                            InfoAdd(fc.RFID.BlockDataAScII)
                            txtData.Text = fc.RFID.BlockDataAScII
                            InfoAdd("Read = OK")
                        Else
                            InfoAdd("No Data found")
                        End If
                    End If

                Else
                    InfoAdd("No UID found")
                End If
            End If
            If cbReadWriteBox.SelectedIndex = 1 Then
                If txtData.Text.Length <> 8 Then
                    InfoAdd("Error. Text need 8 digits Hex")
                    txtData.Focus()
                    Exit Sub
                End If
                InfoAdd("Search UID")
                If fc.RFID.GetUID Then
                    InfoAdd(fc.RFID.UIDNr)
                    fc.PlaySound()
                    'InfoAdd(fc.RFID.TagTyp)
                    If fc.RFID.UIDNr.Length = 24 Then
                        If fc.RFID.WriteTagBlock24(NumBlock.Value, 4, txtData.Text, 0) Then
                            InfoAdd("Write = OK")
                        Else
                            InfoAdd("Write = ERROR")
                        End If
                    End If

                    If fc.RFID.UIDNr.Length = 16 Then
                        If fc.RFID.WriteTagBlock(NumBlock.Value, 2, txtData.Text, 0) Then
                            InfoAdd("Write = OK")
                        Else
                            InfoAdd("Write = ERROR")
                        End If
                    End If
                Else
                    InfoAdd("No UID found")
                End If
            End If
        Finally
            btReadTransponder.Enabled = True
            btReadWriteData.Enabled = True
            btGetVersion.Enabled = True
        End Try
    End Sub

    Private Sub frmHF_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbReadWriteBox.SelectedIndex = 0
    End Sub

    Private Sub cbReadWriteBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbReadWriteBox.SelectedIndexChanged
        btReadWriteData.Text = cbReadWriteBox.Text
    End Sub

    Private Sub ClearItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ListBox1.Items.Clear()
    End Sub

    Private Sub ExitItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitItem.Click
        If cbConti.Checked Then
            cbConti.Checked = False
            InfoAdd("Stop Continues Read")
        End If
        If MsgBox("Close Form ?", MsgBoxStyle.YesNo, Text) = MsgBoxResult.Yes Then
            Close()
        End If
    End Sub

    Private Sub MenuItem1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem1.Click
        ListBox1.Items.Clear()
    End Sub
End Class